#line 44 "attr.nw"
#ifndef ATTR_H
#define ATTR_H

#line 261 "attr.nw"
#include"output.h"

#line 342 "attr.nw"
#define TEXT_ATTRIBUTE_CONTENTS char*
#line 438 "attr.nw"
#define FORMAT_ATTRIBUTE_CONTENTS Format_command
#line 521 "attr.nw"
#define ATTRIBUTELIST_CONTENTS struct {                          \
    Attribute* listenelement; /* contents of this link */        \
    Attributelist *next; /* pointer to the rest of the list */   \
    }


#line 269 "attr.nw"
class Attribute {
public:
    Attribute(); /* The constructor */
    virtual ~Attribute() { }  /* The destructor */
    virtual void print(Output&) = 0; /* The output function */
};

#line 316 "attr.nw"
class Text_attribute : public Attribute {
public:
    Text_attribute(const char*);
    void print(Output&);
    ~Text_attribute();
private:
    TEXT_ATTRIBUTE_CONTENTS contents;
    // for safety:
    Text_attribute();
    Text_attribute(const Text_attribute&);
    const Text_attribute& operator=(const Text_attribute&);
};

#line 413 "attr.nw"
class Format_attribute : public Attribute {
public:
    Format_attribute(Format_command); /* constructor */
    void print(Output&);
    ~Format_attribute();
private:
    FORMAT_ATTRIBUTE_CONTENTS contents;
    // for safety:
    Format_attribute();
    Format_attribute(const Format_attribute&);
    const Format_attribute& operator=(const Format_attribute&);
};

#line 495 "attr.nw"
class Attributelist : public Attribute {
public:
    Attributelist(Attribute*); /* constructor */
    void print(Output&); /* outputs a list of attributes */
    void append(Attribute*); /* appends an attribute to the list */
    ~Attributelist();
private:
    ATTRIBUTELIST_CONTENTS contents;
    // for safety:
    Attributelist();
    Attributelist(const Attributelist&);
    const Attributelist& operator=(const Attributelist&);
};

#line 631 "attr.nw"
Attribute* create (const char *);
Attribute* create (char *);
#line 659 "attr.nw"
Attribute* create (Format_command);
#line 714 "attr.nw"
Attribute*
join(Attribute *a1, Attribute *a2);

#line 757 "attr.nw"
Attribute*
join (Attribute *a1, Attribute *a2, Attribute *a3);

Attribute*
join (Attribute *a1, Attribute *a2, Attribute *a3, Attribute*a4);

Attribute*
join (Attribute *a1, Attribute *a2, Attribute *a3, Attribute*a4,
        Attribute *a5);

Attribute*
join (Attribute *a1, Attribute *a2, Attribute *a3, Attribute*a4,
        Attribute *a5, Attribute *a6);

Attribute*
join (Attribute *a1, Attribute *a2, Attribute *a3, Attribute*a4,
        Attribute *a5, Attribute *a6, Attribute *a7);

Attribute*
join (Attribute *a1, Attribute *a2, Attribute *a3, Attribute*a4,
        Attribute *a5, Attribute *a6, Attribute *a7, Attribute *a8);

Attribute*
join (Attribute *a1, Attribute *a2, Attribute *a3, Attribute*a4,
        Attribute *a5, Attribute *a6, Attribute *a7, Attribute *a8,
        Attribute *a9);

Attribute*
join (Attribute *a1, Attribute *a2, Attribute *a3, Attribute*a4,
        Attribute *a5, Attribute *a6, Attribute *a7, Attribute *a8,
        Attribute *a9, Attribute *a10);

#line 956 "attr.nw"
Attribute*
join (Attribute *a1); /* simply returns [[a1]] */

#line 53 "attr.nw"
#endif

