#line 83 "output.nw"
#ifndef  OUTPUT_H
#define  OUTPUT_H

#line 650 "output.nw"
#include<iostream.h>


#line 484 "output.nw"
#define max_debug_del_size              10

#line 224 "output.nw"
enum Format_command {
    null        = 0,
    indent      = 1,
    outdent     = 2,
    opt0        = 3,
    opt1        = 4,
    opt2        = 5,
    opt3        = 6,
    opt4        = 7,
    opt5        = 8,
    opt6        = 9,
    opt7        = 10,
    opt8        = 11,
    opt9        = 12,
    backup      = 13,
    break_space = 14,
    force       = 15,
    big_force   = 16,
    no_indent   = 17,
    cancel      = 18
};

#line 260 "output.nw"
extern char *Format_command_str[];

#line 427 "output.nw"
class Output {
public:
        Output(ostream& ostr);
        virtual ~Output();
        void do_output(char*);
        void do_output(Format_command);

        
#line 492 "output.nw"
void debug_on(char *bs = "[", char *es = "]" ); /* turn on debug mode */
void debug_off(); /* get back to normal mode again */
#line 435 "output.nw"
protected:
        
#line 505 "output.nw"
enum {                  /* are we debugging or not? */
     yes, no
} debug_mode;
char begin_string[max_debug_del_size+1];
char end_string[max_debug_del_size+1];
#line 626 "output.nw"
Format_command next_output;     /* lookahead */
enum {                  /* type of the lookahead */
    in_use,             /* lookahead is in use */
    empty               /* lookahead is empty */
} next_output_type;
ostream& os;            /* this is where the output is going */
virtual void flush_output() = 0;    /* outputs [[next_output]] to [[os]] */

#line 437 "output.nw"
private:
        
#line 641 "output.nw"
        Output();
        Output(const Output&);
        const Output& operator=(const Output&);

#line 439 "output.nw"
};

#line 961 "output.nw"
class Latex_cweb_output : public Output {
public:
    Latex_cweb_output(ostream& ostr) : Output(ostr) {};
    ~Latex_cweb_output() { flush_output(); };
private:
    void flush_output();
};


#line 93 "output.nw"
#endif
